/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2009.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: sgx/include/sgx/core/xml/xmlparser.hpp

*/

#ifndef SGX_CORE_XML_XMLPARSER_HPP
#define SGX_CORE_XML_XMLPARSER_HPP	1


class sgxXMLStreamCallbackHandler {
public:
	virtual tUINT32	fillBuffer(tBYTE *pBuffer, const tUINT32 maxSize);
};

class CXMLParser {
public:
    static  CXMLParser *	get();
    static  CXMLParser *	create();

	virtual tBOOL			parseStream(sgxXMLTree &tree, sgxXMLStreamCallbackHandler *pHandler);
	virtual tBOOL			parseMemory(sgxXMLTree &tree, const tBYTE *pBuffer, const tUINT32 bufferSize);

protected:
    static  CXMLParser    *ms_pSingleton;
    CXMLParser();
    virtual ~CXMLParser();
};


#endif /* SGX_CORE_XML_XMLPARSER_HPP */
